Loading...
Searching...
No Matches
pcl::SmoothedSurfacesKeypoint< PointT, PointNT > Class Template Reference

Based on the paper: Xinju Li and Igor Guskov Multi-scale features for approximate alignment of point-based surfaces Proceedings of the third Eurographics symposium on Geometry processing July 2005, Vienna, Austria. More...

`#include <pcl/keypoints/smoothed_surfaces_keypoint.h>`

Inheritance diagram for pcl::SmoothedSurfacesKeypoint< PointT, PointNT >:

## Public Types

using | Ptr = shared_ptr< SmoothedSurfacesKeypoint< PointT, PointNT > >
using | ConstPtr = shared_ptr< const SmoothedSurfacesKeypoint< PointT, PointNT > >
using | PointCloudT = pcl::PointCloud< PointT >
using | PointCloudTConstPtr = typename PointCloudT::ConstPtr
using | PointCloudNT = pcl::PointCloud< PointNT >
using | PointCloudNTConstPtr = typename PointCloudNT::ConstPtr
using | PointCloudTPtr = typename PointCloudT::Ptr
using | KdTreePtr = typename Keypoint< PointT, PointT >::KdTreePtr
Public Types inherited from pcl::Keypoint< PointT, PointT >
using | Ptr = shared_ptr< Keypoint< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Keypoint< PointInT, PointOutT > >
using | BaseClass = PCLBase< PointInT >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(pcl::index_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, pcl::index_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| SmoothedSurfacesKeypoint ()
void | addSmoothedPointCloud (const PointCloudTConstPtr &cloud, const PointCloudNTConstPtr &normals, KdTreePtr &kdtree, float &scale)
void | resetClouds ()
void | setNeighborhoodConstant (float neighborhood_constant)
float | getNeighborhoodConstant ()
void | setInputNormals (const PointCloudNTConstPtr &normals)
void | setInputScale (float input_scale)
void | detectKeypoints (PointCloudT &output) override
Public Member Functions inherited from pcl::Keypoint< PointT, PointT >
| Keypoint ()=default
| Keypoint ()
| Empty constructor.
void | harrisCorner (PointT &output, PointT &input, const float sigma_d, const float sigma_i, const float alpha, const float thresh)
void | hessianBlob (PointT &output, PointT &input, const float sigma, bool SCALE)
void | hessianBlob (PointT &output, PointT &input, const float start_scale, const float scaling_factor, const int num_scales)
void | imageElementMultiply (PointT &output, PointT &input1, PointT &input2)
| ~Keypoint () override=default
| Empty destructor.
virtual void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to the input dataset that we need to estimate features at every point for.
PointCloudInConstPtr | getSearchSurface ()
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used.
double | getSearchParameter ()
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch ()
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the key point detection.
double | getRadiusSearch ()
| Get the sphere radius used for determining the neighbors.
pcl::PointIndicesConstPtr | getKeypointsIndices ()
void | compute (PointCloudOut &output)
| Base method for key point detection for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
int | searchForNeighbors (pcl::index_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

bool | initCompute () override
Protected Member Functions inherited from pcl::Keypoint< PointT, PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual void | detectKeypoints (PointCloudOut &output)=0
| Abstract key point detection method.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::Keypoint< PointT, PointT >
std::string | name_
| The key point detection method's name.
SearchMethod | search_method_
| The search method template for indices.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (casted from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
pcl::PointIndicesPtr | keypoints_indices_
| Indices of the keypoints in the input cloud.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT, typename PointNT>
class pcl::SmoothedSurfacesKeypoint< PointT, PointNT >

Based on the paper: Xinju Li and Igor Guskov Multi-scale features for approximate alignment of point-based surfaces Proceedings of the third Eurographics symposium on Geometry processing July 2005, Vienna, Austria.

Author
  Alexandru-Eugen Ichim

Definition at line 54 of file smoothed_surfaces_keypoint.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::ConstPtr = shared_ptr<const SmoothedSurfacesKeypoint<PointT, PointNT> >

Definition at line 58 of file smoothed_surfaces_keypoint.h.

## KdTreePtr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::KdTreePtr = typename Keypoint<PointT, PointT>::KdTreePtr

Definition at line 71 of file smoothed_surfaces_keypoint.h.

## PointCloudNT

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::PointCloudNT = pcl::PointCloud<PointNT>

Definition at line 68 of file smoothed_surfaces_keypoint.h.

## PointCloudNTConstPtr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::PointCloudNTConstPtr = typename PointCloudNT::ConstPtr

Definition at line 69 of file smoothed_surfaces_keypoint.h.

## PointCloudT

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::PointCloudT = pcl::PointCloud<PointT>

Definition at line 66 of file smoothed_surfaces_keypoint.h.

## PointCloudTConstPtr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::PointCloudTConstPtr = typename PointCloudT::ConstPtr

Definition at line 67 of file smoothed_surfaces_keypoint.h.

## PointCloudTPtr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::PointCloudTPtr = typename PointCloudT::Ptr

Definition at line 70 of file smoothed_surfaces_keypoint.h.

## Ptr

template<typename PointT , typename PointNT >

using pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::Ptr = shared_ptr<SmoothedSurfacesKeypoint<PointT, PointNT> >

Definition at line 57 of file smoothed_surfaces_keypoint.h.

## Constructor & Destructor Documentation

## SmoothedSurfacesKeypoint()

template<typename PointT , typename PointNT >

pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::SmoothedSurfacesKeypoint | ( |  | ) |

inline

Definition at line 73 of file smoothed_surfaces_keypoint.h.

References pcl::Keypoint< PointT, PointT >::name_.

## Member Function Documentation

## addSmoothedPointCloud()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::addSmoothedPointCloud | ( | const PointCloudTConstPtr & | cloud,
|  | const PointCloudNTConstPtr & | normals,
|  | KdTreePtr & | kdtree,
|  | float & | scale
| ) |  |

Definition at line 47 of file smoothed_surfaces_keypoint.hpp.

## detectKeypoints()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints | ( | PointCloudT & | output | ) |

override

Definition at line 71 of file smoothed_surfaces_keypoint.hpp.

References pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::push_back(), pcl::search::Search< PointT >::radiusSearch(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## getNeighborhoodConstant()

template<typename PointT , typename PointNT >

float pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::getNeighborhoodConstant | ( |  | ) |

inline

Definition at line 100 of file smoothed_surfaces_keypoint.h.

## initCompute()

template<typename PointT , typename PointNT >

bool pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::initCompute | ( |  | ) |

override protected virtual

Reimplemented from pcl::Keypoint< PointT, PointT >.

Definition at line 182 of file smoothed_surfaces_keypoint.hpp.

## resetClouds()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::resetClouds | ( |  | ) |

Definition at line 61 of file smoothed_surfaces_keypoint.hpp.

## setInputNormals()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::setInputNormals | ( | const PointCloudNTConstPtr & | normals | ) |

inline

Definition at line 103 of file smoothed_surfaces_keypoint.h.

## setInputScale()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::setInputScale | ( | float | input_scale | ) |

inline

Definition at line 106 of file smoothed_surfaces_keypoint.h.

## setNeighborhoodConstant()

template<typename PointT , typename PointNT >

void pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::setNeighborhoodConstant | ( | float | neighborhood_constant | ) |

inline

Definition at line 97 of file smoothed_surfaces_keypoint.h.

The documentation for this class was generated from the following files:

- pcl/keypoints/smoothed_surfaces_keypoint.h
- pcl/keypoints/impl/smoothed_surfaces_keypoint.hpp